
package de.ivu.elect.business.gruppeimgebiet.boundary;

import javax.enterprise.context.RequestScoped;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;

import de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebiet;

@RequestScoped
@Named(GruppeImGebietConversationSelect.COMPONENT_NAME)
public class GruppeImGebietConversationSelect implements java.io.Serializable {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "gruppeImGebietConversationSelect";

  @Inject
  protected transient GruppeImGebietExtendedDAO entityDAO;

  @Inject
  @ConversationGroup(GruppeImGebietConversationStore.class)
  protected transient GruppeImGebietConversationStore conversationStore;

  public GruppeImGebietConversationSelect() {
    super();
  }

  public boolean isSelected() {
    return getEntityPK() != null;
  }

  public GruppeImGebiet getEntity() {
    return getEntityInternal();
  }

  private GruppeImGebiet getEntityInternal() {
    if (getEntityPK() == null) {
      return null;
    }

    return attach(getEntityPK());
  }

  public void setEntity(GruppeImGebiet entity) {
    setEntityAttached(attach(entity));
  }

  public void setEntity( de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK  pk) {
    setEntityAttached(attach(pk));
  }

  protected void setEntityAttached(GruppeImGebiet entity) {
    if(entity == null) {
      setEntityPK(null);
    } else {
      setEntityPK(entity.getPk());
    }
  }

  public
    de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK
   getEntityPK() {
    return conversationStore.getEntityPK();
  }

  public void setEntityPK(
    de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK
   entityPK) {
    conversationStore.setEntityPK(entityPK);
  }

  protected GruppeImGebiet attach(GruppeImGebiet entity) {
    if (entity == null){
      return null;
    }

    return attach(entity.getPk());
  }

  protected GruppeImGebiet attach( de.ivu.elect.business.gruppeimgebiet.entity.GruppeImGebietPK  pk) {
    if (pk == null) {
      return null;
    }

    return entityDAO.findByPrimaryKey(pk);
  }

  public void clearEntity() {
    setEntityPK(null);

    conversationStore.close();
  }
}
